<template>
  <b-modal
    id="importActionModal"
    v-model="isOpen"
    :title="$t('actions.importModalTitle')"
    :cancel-title="$t('Cancel')"
    :ok-disabled="!Boolean(file)"
    :ok-title="$t('Continue')"
    @ok="save"
    @cancel="close"
    @close="close"
    @hidden="hidden"
  >
    {{ $t("actions.importModalDescription") }}
    <hr />
    <b-form-file
      v-model="file"
      class="mb-2"
      :drop-placeholder="$t('actions.importModalDropPlaceholder')"
      :placeholder="$t('actions.importModalFilePlaceholder')"
    ></b-form-file>
    <b-form-select v-model="mimeType" :options="mimeTypes" />
  </b-modal>
</template>

<script lang="ts">
import { getRDFContentTypes } from "@/util/linkedData";
import { defineComponent } from "vue";

export default defineComponent({
  name: "ImportActionModal",
  props: {
    open: {
      required: true,
      default: () => false,
      type: Boolean,
    },
  },
  data() {
    return {
      mimeType: "text/turtle",
      mimeTypes: [
        { value: "application/ld+json", text: "application/ld+json" },
        { value: "text/turtle", text: "text/turtle" },
      ],
      file: null as File | null,
      isOpen: false,
    };
  },
  watch: {
    open() {
      this.isOpen = this.open;
    },
  },
  created() {
    this.getMimeTypes();
  },
  methods: {
    close() {
      this.isOpen = false;
    },
    async getMimeTypes() {
      const contentTypes = await getRDFContentTypes();
      this.mimeTypes = [];
      for (const contentType of contentTypes) {
        this.mimeTypes.push({ value: contentType, text: contentType });
      }
    },
    hidden() {
      this.$emit("close");
    },
    save() {
      if (this.file !== null) {
        this.$emit("save", this.file, this.mimeType);
      }
    },
  },
});
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped></style>
